unit makemap1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Buttons, StdCtrls, Menus, ComCtrls;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Bild: TPaintBox;
    Opend: TOpenDialog;
    PopupMenu1: TPopupMenu;
    miShowMap: TMenuItem;
    miSetMap: TMenuItem;
    Bar: TStatusBar;
    Memo1: TMemo;
    Splitter1: TSplitter;
    PopupMenu2: TPopupMenu;
    pm21: TMenuItem;
    pm22: TMenuItem;
    pm23: TMenuItem;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    ToolButton1: TSpeedButton;
    ComboBox1: TComboBox;
    btnZoom: TSpeedButton;
    PaintBox1: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BildPaint(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure BildMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BildMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BildMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BildDblClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure miSetMapClick(Sender: TObject);
    procedure miShowMapClick(Sender: TObject);
    procedure btnzoomClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure BildDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure BildDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure PopupMenu2Popup(Sender: TObject);
    procedure pm21Click(Sender: TObject);
    procedure pm22Click(Sender: TObject);
    procedure pm23Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
  private
    { Private-Deklarationen }
    function GetZoom : integer;
    procedure UpdateBild;
//    procedure GetImgs;
    procedure AddMap ( x , y : Integer ; Ctrl : Boolean);
    function CoordToStr ( Value : Integer ) : string;
    procedure DrawMap ( s : string ; tc : TCanvas ; aZoom : Integer ; aPenMode : TPenMode );
    procedure DrawSelectedMap ( s : string ; tc : TCanvas ; aZoom : Integer ) ;
    function GetCoord ( var s : string ; a : Integer ) : Integer;
    procedure StretchBild ( aBmp : TBitmap );
    function GetVisibleRect : TRect;
    function FindMap ( x,y : Integer ) : Integer;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  myimg,tbmp :tbitmap;
  map : tstrings;
  DraggedLine : string;
  aktMap : Integer = -1;
  points : tstrings;
  WorkMode : integer = 1;
  ismode : boolean = false;
  oldx,oldy : integer;
  pts : array [0..500] of tpoint;
  ptix : integer = 0;
  allownext : boolean = true;
  allowchange : boolean = true;
  canchange : boolean = true;

const
     zoom : array [-1..3] of byte = (1,1,2,4,8);

implementation

uses makemap2;


{$R *.DFM}

function TForm1.GetVisibleRect:TRect;
begin
     with ScrollBox1 do begin
          Result.Left   := HorzScrollBar.ScrollPos;
          Result.Top    := VertScrollBar.ScrollPos;
          Result.Right  := ClientWidth + Result.Left;
          Result.Bottom := ClientHeight + Result.Top;

          if Result.Right >= Bild.Width
          then
              Result.Right := Pred ( Bild.Width );

          if Result.Bottom >= Bild.Height
          then
              Result.Bottom := Pred ( Bild.Height );
     end;
end;

procedure TForm1.StretchBild ( aBmp : TBitmap );
var
   rc1:trect;
   xd,yd,hd,wd,xs,ys,hs,ws : Integer;
   zm : Integer;
begin
     rc1 := GetVisibleRect;

     xd  := rc1.Left-2;
     yd  := rc1.Top-2;
     wd  := rc1.Right-xd+4;
     hd  := rc1.Bottom-yd+4;
     zm  := GetZoom;

     xs  := xd div zm;
     ys  := yd div zm;
     hs  := hd div zm;
     ws  := wd div zm;

     StretchBlt ( Bild.Canvas.Handle , xd,yd,wd,hd,aBmp.Canvas.Handle , xs,ys,ws,hs,SRCCopy);

//     Bild.Canvas.CopyRect ( rc1 , aBmp.Canvas , rc2 );

     fmZoom.FormPaint(nil);
end;

function TForm1.GetCoord (var s : string ; a : Integer ) : Integer;
var
   t : Integer;
begin
     Result := MaxInt;

     if Length(s) < 2
     then
         Exit;

     if s[1] = ','
     then
          Delete ( s , 1 , 1 );

     t := Pos ( ',' , s );
     if t = 0
     then
         t := Pred ( MaxInt );

     Result := StrToIntDef ( Copy ( s , 1 , Pred ( t ) ) , Maxint ) * a;

     s := Copy ( s , t , MaxInt );
end;

procedure TForm1.DrawSelectedMap ( s : string ; tc : TCanvas ; aZoom : Integer ) ;
var
   ch : Char;
   a,b,c,d : Integer;
   tmt : array [0..500] of TPoint;

begin
     ch := s[1];
     Delete ( s , 1 , 1 );

     with tc
     do begin
        Pen.Mode := pmNot;
        Brush.Style := bsSolid;
        if ch <> 'p'
        then begin
             a := GetCoord ( s , aZoom );
             b := GetCoord ( s , aZoom );
             c := GetCoord ( s , aZoom );
             d := GetCoord ( s , aZoom );

             if ( d = MaxInt ) and ( ch = 'c' )
             then
                 d := ( c - a ) + b;
        end;

        case ch of
             'c' : Ellipse ( a , b , c , d );
             'p' : begin
                        a := 0;
                        b := GetCoord ( s , aZoom );
                        while b < Pred ( MaxInt )
                        do begin
                           tmt[a].x := b;
                           tmt[a].y := GetCoord ( s , aZoom );
                           Inc(a);
                           b := GetCoord ( s , aZoom );
                        end;

                        Polygon ( Slice ( tmt , Pred ( a ) ) );
                   end;
             'r' : Rectangle ( a , b , c , d );
        end;
     end;
end;

procedure TForm1.DrawMap ( s : string ; tc : TCanvas ; aZoom : Integer ; aPenMode : TPenMode );
var
   ch : Char;
   a,b,c,d : Integer;
   tmt : array [0..500] of TPoint;

begin
     ch := s[1];
     Delete ( s , 1 , 1 );

     with tc
     do begin
        Pen.Mode := aPenMode;
        Pen.Color := clGray;
        Brush.Style := bsClear;

        if ch <> 'p'
        then begin
             a := GetCoord ( s , aZoom );
             b := GetCoord ( s , aZoom );
             c := GetCoord ( s , aZoom );
             d := GetCoord ( s , aZoom );

             if ( d = MaxInt ) and ( ch = 'c' )
             then
                 d := ( c - a ) + b;
        end;

        case ch of
             'c' : Ellipse ( a , b , c , d );
             'p' : begin
                        a := 0;
                        b := GetCoord ( s , aZoom );
                        while b < Pred ( MaxInt )
                        do begin
                           tmt[a].x := b;
                           tmt[a].y := GetCoord ( s , aZoom );
                           Inc(a);
                           b := GetCoord ( s , aZoom );
                        end;

                        Polygon ( Slice ( tmt , Pred ( a ) ) );
                   end;
             'r' : Rectangle ( a , b , c , d );
        end;
     end;
end;

function TForm1.CoordToStr ( Value : Integer ):string;
begin
     Result := ',' + IntToStr ( Value div GetZoom );
end;

procedure TForm1.AddMap ( x , y : Integer ; Ctrl : Boolean);
const
     md : array [1..3] of Char = ('r','c','p');
var
   sr : string;
   t : Integer;

begin
     if not ( WorkMode in [1,2,3] )
     then
         Exit;

     sr := md[WorkMode];

     if WorkMode <> 3
     then begin

          if (Abs(x - oldx) < GetZoom ) or (Abs(y - oldy) < GetZoom )
          then begin
               UpdateBild;
               Exit;
          end;

          if Ctrl
          then
              sr := sr + CoordToStr ( oldx ) + CoordToStr ( oldy ) + CoordToStr ( x ) + CoordToStr ( ( oldy + ( x - oldx ) ) )
          else
              sr := sr + CoordToStr ( oldx ) + CoordToStr ( oldy ) + CoordToStr ( x ) + CoordToStr ( y );

          map.Add ( sr );
          Memo1.Lines.Add ( sr );
          UpdateBild;
          Exit;
     end;

     if ptix < 2
     then
         Exit;

     for t := 0 to Pred ( ptix )
     do
       sr := sr + CoordToStr ( pts[t].x ) + CoordToStr ( pts[t].y );

     Map.Add ( sr );
     Memo1.Lines.Add ( sr );
     UpdateBild;

end;

procedure TForm1.UpdateBild;
begin
     ismode := False;
     Bild.Width := myimg.Width * GetZoom;
     Bild.Height := myimg.Height * GetZoom;
     BildPaint ( nil );
end;

function TForm1.GetZoom : Integer;
begin
     Result := zoom [ ComboBox1.ItemIndex ];
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     myimg := TBitmap.Create;
     map   := TStringList.Create;
     tbmp  := TBitmap.Create;
     ComboBox1.ItemIndex := 0;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     myimg.Free;
     tbmp.Free;
     map.Free;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
   sr : TFileName;
begin
     with OpenD
     do begin
        Title := 'Open map';
        if Execute
        then begin
             sr := FileName;

             if not FileExists ( sr )
             then
                 Exit;

             myimg.LoadFromFile ( sr );
             fmZoom.RePaint;

             sr := ChangeFileExt ( sr , '.map' );
             map.Clear;
             if FileExists ( sr )
             then
                 map.LoadFromFile ( sr );

             Memo1.Lines.Assign ( map );
             UpdateBild;

             ToolButton1.down := True;
             WorkMode := 4;

        end;
     end;
end;

procedure TForm1.BildPaint(Sender: TObject);
var
   t : Integer;

begin
     clr := GetVisibleRect;

     tbmp.Width := myimg.Width;
     tbmp.Height := myimg.Height;

     with tbmp.Canvas
     do begin
     	Draw ( 0 , 0 , myimg );
        Pen.Style := psDot;
        if map.Count > 0
        then
            for t := 0 to Pred ( map.Count )
            do begin
               if t = aktMap
               then
                   DrawSelectedMap ( map [ t ] , tbmp.Canvas  , 1 )
               else
                   DrawMap ( map [ t ] , tbmp.Canvas , 1 , pmCopy );
            end;
     end;
     StretchBild ( tbmp );
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
     UpdateBild;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
var
   sr : TFileName;
begin
     sr := OpenD.FileName;
     if not FileExists ( sr )
     then
         with OpenD
         do begin
            Title := 'Save map';
            if not Execute
            then
                Exit;

            sr := ChangeFileExt ( OpenD.FileName , '.map' );
         end;

     sr := ChangeFileExt ( sr , '.map' );
     map.SaveToFile ( sr );
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
     ismode := False;
     WorkMode := ( Sender as TSpeedButton ).Tag;
     UpdateBild;
end;

procedure TForm1.BildMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   t : Integer;

begin
     if ssRight in Shift
     then
         Exit;

     bar.Panels[0].Text := Format ( 'X: %d  Y:%d' , [ x div GetZoom , y div GetZoom ] );
     if not ismode
     then
         Exit;

     if WorkMode = 4
     then begin
          if aktMap = -1
          then
              Exit;
          if (Abs(x-oldx) > (2*GetZoom)) or (Abs(y-oldy) > (2*GetZoom))
          then begin
               DraggedLine := Map[aktMap];
               Bild.BeginDrag ( True );
          end;
     end;
             
     with bild.Canvas
     do begin
        StretchBild ( tbmp );
        Pen.Mode := pmNot;
        Brush.Style := bsClear;
        pen.Width := GetZoom;
        case WorkMode of
             1 : begin
                      if ssCtrl in Shift
                      then
                          Rectangle( oldx , oldy , x , oldy+(x-oldx) )
                      else
                          Rectangle( oldx , oldy , x , y );
                   (*   if ssCtrl in Shift
                      then
                          Rectangle( oldx div getzoom*getzoom,oldy div getzoom*getzoom,
                                     x div getzoom*getzoom,(oldy+(x-oldx)) div getzoom*getzoom)
                      else
                          Rectangle( oldx div getzoom*getzoom,oldy div getzoom*getzoom,
                                     x div getzoom*getzoom,y div getzoom*getzoom);*)
                 end;
             2 : begin
                      if ssCtrl in Shift
                      then
                          Ellipse( oldx , oldy , x , oldy+(x-oldx) )
                      else
                          Ellipse( oldx , oldy , x , y );
                 end;
             3 : begin
                      if ptix = 0
                      then
                          Exit;

                      MoveTo ( pts [ 0 ].x , pts[0].y );

                      if ptix > 1
                      then
                          for t := 1 to Pred ( ptix )
                          do
                            LineTo ( pts[t].x , pts[t].y );

                      LineTo ( x , y );
                 end;
        end;
     end;
end;

procedure TForm1.BildMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     if ssRight in Shift
     then
         Exit;

     if not allownext then begin
        allownext := true;
        exit;
     end;
     if not ismode then bildpaint(nil);
     oldx := x;
     oldy := y;
     if not ismode then ptix := 0;
     ismode := true;
     if WorkMode = 3 then begin
        if ptix > 500 then exit;
        pts [ptix].x := x div getzoom*getzoom;
        pts [ptix].y := y div getzoom*getzoom;
        inc (ptix);
     end;

     if WorkMode = 4
     then
         aktMap := FindMap (x,y);
end;
procedure TForm1.BildMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     if ismode
     then
         if ( WorkMode in [1,2] )
         then begin
              addmap(x,y , ssCtrl in Shift);
              ismode := false;
         end
         else
             if WorkMode = 4
             then begin
                  isMode := False;
                  BildPaint ( nil );
             end;
end;

procedure TForm1.BildDblClick(Sender: TObject);
begin
     if ismode
     then
         if WorkMode = 3
         then
             Addmap(0,0 , False);
     ismode := false;
     ptix :=0;
     allownext := false;
     ToolButton1.down := True;
     WorkMode := 4;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key = vk_escape
     then begin
          CancelDrag;
          UpdateBild;
     end;
end;

procedure TForm1.miSetMapClick(Sender: TObject);
var
   t : integer;
begin
     t := SendMessage(memo1.Handle, EM_LINEFROMCHAR, memo1.SelStart, 0);
     aktMap := t;
     updatebild;

end;

procedure TForm1.miShowMapClick(Sender: TObject);
begin
     map.assign(memo1.lines);
     updatebild;
end;

procedure TForm1.btnzoomClick(Sender: TObject);
begin
     fmzoom.visible := btnzoom.down;
     fmzoom.repaint;
end;

    function getza(var s:string) : integer;
    var a : integer;
    begin
         a := pos (',',s);
         if a = 0 then a := maxint-1;
         result := strtointdef(copy(s,1,a-1),maxint);
         s:=copy(s,a+1,maxint);
    end;

    function getrc (sr : string):trect;
    begin
         result.left := getza(sr);
         result.top := getza(sr);
         result.right := getza(sr);
         result.bottom := getza(sr);
    end;
    function getar (var ar : array of tpoint;sr : string):integer;
    var a : integer;
    begin
         result := 0;
         a := getza(sr);
         while a < maxint-1 do begin
               ar[result].x := a;
               a:=getza(sr);
               ar[result].y:=a;
               inc(result);
               a:=getza(sr);
         end;
    end;


function isinreg(x,y:integer;sr : string):boolean;
var ptar : array [0..500] of tpoint;
    ptix,rg : integer;
    ch : char;
    arps : tpoint;
    rc : trect;

begin
     result := false;
     if sr = '' then exit;
     ch := sr[1];
     delete(sr,1,2);
     arps.x := x;
     arps.y := y;
     case ch of
          'c': begin
                    rc := getrc(sr);
                    if rc.Bottom = MaxInt
                    then
                        ptix := CreateEllipticRgn( rc.left,rc.top,rc.right,
                                                   rc.top+(rc.right-rc.left))
                    else
                        ptix := CreateEllipticRgn( rc.left,rc.top,rc.right,
                                                   rc.Bottom);
                    result := ptinregion(ptix,x,y);
                    deleteobject(ptix);
               end;
          'p': begin
                    ptix := getar(ptar,sr);
                    rg := createpolygonrgn(ptar,ptix,winding);
                    result := ptinregion(rg,x,y);
                    deleteobject(rg);
               end;
          'r': result := ptinrect(getrc(sr),arps);
     end;
end;

function TForm1.FindMap ( x,y : Integer ) : Integer;
var ct : integer;
    sr : string;
begin
     // map holen
     x := x div GetZoom;
     y := y div GetZoom;
     Result := -1;
     if map.count > 0
     then
         for ct := Pred ( map.count ) downto 0
         do begin
            sr := map[ct];
            if isinreg(x,y,sr)
            then begin
                 Result := ct;
                 Exit;
            end;
         end;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
//ShellExecute(Application.Handle,PChar('open'),PChar('http://home.t-online.de/home/mirbir.st/'),PChar(''),nil,SW_NORMAL);

end;

function OffsetLine ( src : string ; dX , dY : Integer ): string;
var
   dst : string;
   ct : Integer;
   xmod : Boolean;
begin
     dst := '';
     ct := Pos ( ',' , src );
     if ct < 2
     then
         Exit;
     dst := Copy ( src , 1 , ct );
     Delete ( src , 1 , ct );
     ct := GetZa ( src );
     xmod := True;
     while ct < maxint -1
     do begin
        if xmod
        then
            ct := ct+dX
        else
            ct := ct+dY;
        xmod := not Xmod;
        dst := dst+IntToStr ( ct)+',';
        ct := GetZa ( src );
     end;
     dst := dst+src;
     Result := dst;
end;

procedure TForm1.BildDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var
   sr : string;
begin
     Accept := ( Sender = Source );
     if Accept
     then begin
          sr := OffsetLine ( DraggedLine , (x-oldx) div GetZoom , (y-oldy) div GetZoom );
          Map[aktMap] := sr;
          BildPaint ( nil );
          Map[aktMap] := DraggedLine;
     end;
end;

procedure TForm1.BildDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
     if (Sender = Source )
     then begin
          Map.Delete ( aktMap);
          aktMap := Map.Add (OffsetLine ( DraggedLine , (x-oldx) div GetZoom , (y-oldy) div GetZoom ));
          BildPaint(nil);
          Memo1.Lines.Assign ( Map );
     end;
end;

procedure TForm1.PopupMenu2Popup(Sender: TObject);
var
   pt : TPoint;
begin
     GetCursorPos ( pt );
     pt := Bild.ScreenToClient ( pt );
     aktMap := FindMap ( pt.x,pt.y);
     BildPaint ( nil );
     if aktMap <> -1
     then begin
          pm21.Visible := True;
          pm22.Visible := True;
          pm23.Visible := True;
     end
     else begin
          pm21.Visible := False;
          pm22.Visible := False;
          pm23.Visible := False;
     end;
end;

procedure TForm1.pm21Click(Sender: TObject);
var
   sr : string;
begin
     sr := Map[aktMap];
     Map.Delete ( aktMap);
     aktMap := Map.Add ( sr );
     Memo1.Lines.Assign ( Map );
     BildPaint(nil);
end;

procedure TForm1.pm22Click(Sender: TObject);
var
   sr : string;
begin
     sr := Map[aktMap];
     Map.Delete ( aktMap);
     Map.Insert ( 0, sr );
     aktMap := 0;
     Memo1.Lines.Assign ( Map );
     BildPaint(nil);
end;

procedure TForm1.pm23Click(Sender: TObject);
var
   sr : string;
begin
     sr := Map[aktMap];
     Map.Delete ( aktMap);
     aktMap := -1;
     Memo1.Lines.Assign ( Map );
     BildPaint(nil);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
   sr : string;
   h : Integer;
begin
     with PaintBox1.Canvas
     do begin
        Draw ( 0,2, Application.Icon );
        sr := 'TMapImage V1.1';
        h := TextHeight ( 'yY' );
        h := (Application.Icon.Height - h) div 2;
        TextOut ( Application.Icon.Width+4 , h+2 , sr );
     end;
end;

end.
