unit movereg1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, mapimg, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    MapImage1: TMapImage;
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    Nodescription1: TMenuItem;
    Changedescription1: TMenuItem;
    Memo1: TMemo;
    PaintBox1: TPaintBox;
    procedure MapImage1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MapImage1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure MapImage1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure MapImage1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure MapImage1DblClick(Sender: TObject);
    procedure MapImage1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Changedescription1Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure DrawMap ( Index : Integer );
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  TBmp : TBitmap;
  DragMap : Integer;
  ClickMap : Integer;
  Xdr,Ydr : Integer;
  DragSr  : string;

implementation

{$R *.DFM}

procedure TForm1.MapImage1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var t   :Integer;
begin
     MapImage1.Canvas.Draw ( 0, 0 , TBmp );
     MapImage1.Canvas.Brush.Color := clblack;

     t := MapImage1.GetMapAtCursorPos;

     DragMap := t;

     if t = -1
     then
         Exit;

     XDr := X;
     YDr := Y;
     DragSr := MapImage1.Map [DragMap];

     DrawMap(t);

end;

procedure TForm1.DrawMap ( Index : Integer );
var
   i1 : Integer;
begin
     i1 := MapImage1.CreateRegion(Index);

     with MapImage1.Canvas
     do
       if i1 <> 0
       then begin
            SelectObject(Handle,i1);
            Rectangle(0,0,MapImage1.Width,MapImage1.Height);
            DeleteObject(i1);
       end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     TBmp := TBitmap.Create;
     TBmp.Assign ( MapImage1.Picture.Bitmap );
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     TBmp.Free;
end;

procedure TForm1.MapImage1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
     MapImage1.Canvas.Draw ( 0,0,TBmp );
     Accept := Sender = Source;
     if Accept
     then begin
          MapImage1.Map[DragMap] := DragSr;
          MapImage1.OffsetMap ( DragMap , x-xdr , y-ydr );
          DrawMap(DragMap);
     end;
end;

procedure TForm1.MapImage1DragDrop(Sender, Source: TObject; X, Y: Integer);
begin
     MapImage1.Map[DragMap] := DragSr;
     MapImage1.OffsetMap ( DragMap , x-xdr , y-ydr );
     MapImage1.Canvas.Draw ( 0 , 0 , TBmp );
end;

procedure TForm1.MapImage1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     MapImage1.Canvas.Draw ( 0, 0 , TBmp );

     if ssLeft in Shift
     then
         if (Abs(x-xdr)>2) or (Abs(y-ydr)>2)
         then
             if DragMap > -1
             then
                 MapImage1.BeginDrag(False);
end;

procedure TForm1.MapImage1DblClick(Sender: TObject);
var pt : TPoint;
    sr : string;
begin
     Timer1.Enabled := False;
     ClickMap := MapImage1.GetMapAtCursorPos;
     if ClickMap > -1
     then
         with PopUpMenu1
         do begin
            GetCursorPos ( pt );
            sr := MapImage1.GetDescription ( ClickMap );
            if sr = ''
            then
                Nodescription1.Caption := '(No description)'
            else
                Nodescription1.Caption := sr;
            NoDescription1.Enabled := sr <> '';
            PopupMenu1.Popup ( pt.x,pt.y);
         end;

end;

procedure TForm1.MapImage1Click(Sender: TObject);
var
   pt : TPoint;

begin

     GetCursorPos ( pt );
     pt := MapImage1.ScreenToClient ( pt );
     ClickMap := MapImage1.GetMapAtCursorPos;
     if (Abs(xdr-pt.x) < 2) and (Abs(ydr-pt.y) < 2)
     then
          Timer1.Enabled := True;


end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
     Timer1.Enabled := False;
     if ClickMap > -1
     then
         ShowMessage ( 'Jump to : '+MapImage1.GetDescription ( ClickMap ) );

end;

procedure TForm1.Changedescription1Click(Sender: TObject);
var
   sr : string;
begin
     sr := MapImage1.GetDescription ( ClickMap );
     If InputQuery ( 'Change URL' , 'Please type new URL' , sr )
     then
          MapImage1.SetDescription ( ClickMap , sr );
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
   sr : string;
   h : Integer;
begin
     with PaintBox1.Canvas
     do begin
        Draw ( 0,0, Application.Icon );
        sr := 'TMapImage V1.1';
        h := TextHeight ( 'yY' );
        h := (Application.Icon.Height - h) div 2;
        TextOut ( Application.Icon.Width+4 , h , sr );
     end;
end;

end.
